import create from 'dd-store'
import pageStore from './store';
import { checkFullScren } from "../../utils/checkFullScren";
import { selectPeople, selectedelRequired } from "../../utils/utils";
import { modifySchedule, addSchedule, getUserScheduleInTime, getHomeUserSchedule } from '../../api/request.js'


create.Page({
  store: pageStore,
  useAll: true,
  data: {
    $data: null,

    scheduleItem: '',
    // 登陆当前账户的人 权限
    currentPeople: '',
    organizer: '',
    isIPX: false,
    contactPeople: {},
    showContactPeople: [],
    originUsersId: [],
    confirmAttendance: null,
    isUpdate: false
  },
  onLoad(event) {
    this.setData({
      confirmAttendance: event.confirmAttendance,
      isIPX: checkFullScren(),
      scheduleItem: event.scheduleItem,
      organizer: event.organizer,
      currentPeople: getApp().globalData.userid,
      contactPeople: { ...this.$store.data.participatorList },
      showContactPeople: [...this.$store.data.showParticipatorList],
      originUsersId: Object.keys(this.$store.data.participatorList)
    })

  },
  onShow() {
    this.getParticipatorLength()
  },
  // 添加参会人 钉钉选人  
  addParticipator() {
    let require = []
    let select = []

    // 创建的 可选 必选
    if (!this.data.scheduleItem) {
      require = [getApp().globalData.userid]
      select = selectedelRequired(Object.keys(this.$store.data.participatorList), require)
    }
    // 发起人 可选 必选
    else if (this.data.currentPeople === this.data.organizer) {
      require = [this.data.currentPeople]
      select = selectedelRequired(Object.keys(this.data.contactPeople), require)
    }
    // 编辑 参会人可选必选
    else {
      require = Object.keys(this.$store.data.participatorList)
      select = selectedelRequired(Object.keys(this.data.contactPeople), require)
    }
    selectPeople(select, require).then(res => {
      this.setData({
        isUpdate: true
      })
      const participatorList = {}
      // 创建的 可选 必选
      if (!this.data.scheduleItem) {
        participatorList[getApp().globalData.userid] = {
          userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk'
        }

      }
      // 发起人 可选 必选
      else if (this.data.currentPeople === this.data.organizer) {
        participatorList[getApp().globalData.userid] = {
          userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk', confirmAttendance: this.data.confirmAttendance
        }
      }
      // 编辑 参会人可选必选
      else {
        const showContactPeople = this.data.showContactPeople
        for (let i = 0; i < this.data.showContactPeople.length; i++) {
          participatorList[showContactPeople[i].userId] = { userId: showContactPeople[i].userId, username: showContactPeople[i].username, headUrl: showContactPeople[i].headUrl, platform: 'dingtalk' }
        }
      }
      for (let i = 0; i < res.users.length; i++) {
        participatorList[res.users[i].userId] = { userId: res.users[i].userId, username: res.users[i].name, headUrl: res.users[i].avatar, platform: 'dingtalk' }
      }

      if (this.data.scheduleItem) {
        this.setData({
          contactPeople: participatorList,
          showContactPeople: Object.values(participatorList)
        })
      } else {
        this.$store.data.participatorList = participatorList
        this.$store.data.showParticipatorList = Object.values(participatorList)
        this.update()
      }
      this.getParticipatorLength()
    })
  },
  // 删除参会人
  delParticipants(event) {
    this.setData({
      isUpdate: true
    })

    let userId = event.target.dataset.userId
    let participatorList = {}
    let showParticipatorList = []
    if (this.data.scheduleItem) {
      participatorList = { ...this.data.contactPeople }
      showParticipatorList = [...this.data.showContactPeople]
    } else {
      participatorList = { ...this.$store.data.participatorList }
      showParticipatorList = [...this.$store.data.showParticipatorList]
    }

    delete participatorList[userId]
    for (let i = 0; i < showParticipatorList.length; i++) {
      if (showParticipatorList[i].userId === userId) {
        showParticipatorList.splice(i, 1)
      }
    }

    if (this.data.scheduleItem) {
      this.setData({
        contactPeople: participatorList,
        showContactPeople: showParticipatorList
      })
      this.$store.data.updateInfo = {
        updateType: 'operate_user',
        isUpate: true
      }
    } else {
      this.$store.data.participatorList = participatorList
      this.$store.data.showParticipatorList = showParticipatorList
      this.update()
    }

    this.getParticipatorLength()
  },

  // 保存信息
  saveInfo() {

    this.$store.data.participatorList = this.data.contactPeople
    this.$store.data.showParticipatorList = this.data.showContactPeople
    this.update()

    if (this.data.isUpdate) {
      this.$store.data.updateInfo = {
        updateType: 'operate_user',
        isUpate: true
      }
    }

    this.update()
    dd.navigateBack({
      delta: 1
    })

  },
  // 获取参会人长度
  getParticipatorLength() {
    let length = 0
    if (this.data.scheduleItem) {
      length = this.data.showContactPeople.length

    } else {
      length = this.$store.data.showParticipatorList.length

    }
    dd.setNavigationBar({
      title: `参会人(${length}人）`
    })
  },
});